



<!DOCTYPE html><html lang=zh-CN><head><meta http-equiv="Content-Type" content="text/html; charset=utf-8" /><meta http-equiv="X-UA-Compatible" content="IE=edge,chrome=1"><meta name="applicable-device" content="pc,mobile"><meta name="renderer" content="webkit"><meta name="viewport" content="width=device-width,initial-scale=1.0,maximum-scale=5,viewport-fit=cover">
<title>SIFT四部曲之——高斯滤波</title>	
<script src="//n4.ikafan.com/assets/run_prettify.js?ac"></script>
<link rel="stylesheet" href="//n4.ikafan.com/assetsg/style.css">
<!-- <link rel="stylesheet" href="//pic.ikafan.com/staticx/shuzhiduo/1/css.grace/fontello.css?ac"> -->
<!-- <link rel="stylesheet" href="//pic.ikafan.com/staticx/shuzhiduo/1/css.grace/animation.css?ac"> -->
<script>
var _hmt = _hmt || [];
(function() {
  var hm = document.createElement("script");
  hm.src = "https://hm.baidu.com/hm.js?c61d51e9fdcf1d1631ddfce8df9cd119";
  var s = document.getElementsByTagName("script")[0]; 
  s.parentNode.insertBefore(hm, s);
})();
</script>
<script src="https://n4.ikafan.com/g/show.js"></script>

</head>
<div id="header" class="navbar navbar-default navbar-fixed-top header-01">
	<div class="container">
		<h1 class="logo">
			<a  href="/" title="巴特西"/>
							巴特西
			</a>
		</h1>
				<div role="navigation"  class="site-nav  primary-menu">
			<div class="menu-fix-box">
				 <ul id="menu-navigation" class="menu" >
<li><a href="/">首页</a></li>
<!-- <li><a href="/search/Hadoop/">Hadoop</a></li>
<li><a href="/search/Linux/">Linux</a></li>
<li><a href="/search/jQuery/">jQuery</a></li> -->
<li><a href="/search/Python/">Python</a></li>
<li><a href="/search/Java/">Java</a></li>
<li><a href="/search/PHP/">PHP</a></li>
<li><a href="/search/IOS/">IOS</a></li>
<li><a href="/search/Andorid/">Andorid</a></li>
<li><a href="/search/NodeJS/">NodeJS</a></li>
<li><a href="/search/JavaScript/">JavaScript</a></li>
<li><a href="/search/HTML5/">HTML5</a></li>
				</ul>					 			
			</div>
		</div>
				<!--<div class="right-nav">
				<button class="js-toggle-search"><i class="icon-search"></i></button>
		</div>-->
       
			</div>	
</div>

<div id="page-content">
	<div class="container">
		<div class="row">
			
			<div class="blog-post">
								<!--<div class="posts-top-cjtz clearfix"></div>-->
								<div class="post">
										<div class="post-title">
											<div id="title_top"></div>
<script>insertAdIfNeeded();</script>
						<h1 class="title">SIFT四部曲之——高斯滤波</h1>
						<div class="post_icon">
							<span class="icon-clock-1"> 2024-03-23 01:41:46 </span>
						</div>
										<div class="post-content">
													<div id="single_top"></div>
<script>insertAdIfNeeded();</script>
											
		<p>本文为原创作品，未经本人同意，禁止转载</p>
<p>欢迎关注我的博客：<a href="http://blog.csdn.net/hit2015spring" rel="external nofollow noreferrer">http://blog.csdn.net/hit2015spring</a>和http://www.cnblogs.com/xujianqing/</p>
<p>或许网络上有各位牛人已经对sift算法进行各种的详解和说明，我（小菜鸟）在翻阅各种资料和对opencv中的代码进行反推之后，终于理解该算法。并记录之，供大家一起交流学习！这个博文主要记录了我的学习历程，或许对你有帮助，或许可以启发你，或许你只是一笑而过！没关系，至少自己总结过。</p>
<p>这篇文章主要是对sift算法的每一个步骤，每一个参数进行说明，并在最后用matlab实现该算法，从理论到代码实现或许需要考虑方方面面，但是它并不是那么的难！</p>
<h1>1、算法简介</h1>
<p>开始之前要例行一些东西，对sift的简单介绍。如果不想看直接跳到第二部分，没问题！</p>
<p>Sift（Scale-invariant feature transform）尺度不变特征转换，CV界中赫赫有名的算法，由David Lowe（图1的老头）提出，该算法受专利保护，专利权属于英属哥伦比亚大学。</p>
<p><img referrerpolicy="no-referrer"src="https://images2015.cnblogs.com/blog/871557/201610/871557-20161022224950935-1094851755.png" /></p>
<p>图1 David Lowe</p>
<p>Sift算法可以将一幅图像映射（变换）为一个局部特征向量集；特征向量具有平移、缩放、旋转不变性，同时对光照变化、仿射及投影变换也有一定的不变性。</p>
<p>SIFT算法的特点有：（只是理论，所以看看就好）</p>
<p>1.SIFT特征是图像的局部特征，其对旋转、尺度缩放、亮度变化保持不变性，对视角变化、仿射变换、噪声也保持一定程度的稳定性；</p>
<p>2.独特性（Distinctiveness）好，信息量丰富，适用于在海量特征数据库中进行快速、准确的匹配；</p>
<p>3.多量性，即使少数的几个物体也可以产生大量的特征向量；</p>
<p>4.高速性，经优化的匹配算法甚至可以达到实时的要求；</p>
<p>5.可扩展性，可以很方便的与其他形式的特征向量进行联合。</p>
<p>SIFT算法可以解决的问题：</p>
<p>目标的自身状态、场景所处的环境和成像器材的成像特性等因素影响图像配准目标识别跟踪的性能。而算法在一定程度上可解决：</p>
<p>1.目标的旋转、缩放、平移</p>
<p>2.投影变换</p>
<p>3.光照影响</p>
<p>4.目标遮挡</p>
<p>5.杂物场景</p>
<p>SIFT算法的实质是在不同的尺度空间上查找关键点，并计算出关键点的方向。所查找到的关键点是一些十分突出，不会因光照，仿射变换和噪音等因素而变化的点，如角点、边缘点、暗区的亮点及亮区的暗点等。</p>
<p>SIFT算法可以分解为如下四步：</p>
<p>1.高斯差分（DoG）滤波：搜索所有尺度上的图像位置。通过高斯微分函数来识别潜在的对于尺度和旋转不变的兴趣点。</p>
<p>2.尺度空间的极值检测和关键点位置确定：对DoG金字塔中的每一层，进行尺度空间的极值检测（极大值和极小值），把每一个极值点作为候选点，在每个候选的位置上，通过一个拟合精细的模型来确定位置和尺度。关键点的选择依据于它们的稳定程度。</p>
<p>3.关键点方向确定：基于图像局部的梯度方向，分配给每个关键点位置一个或多个方向。所有后面的对图像数据的操作都相对于关键点的方向、尺度和位置进行变换，从而提供对于这些变换的不变性。</p>
<p>4.构建关键点特征描述符：在每个关键点周围的内，在选定的尺度上测量图像局部的梯度。这些梯度被变换成一种表示，这种表示允许比较大的局部形状的变形和光照变化。</p>
<h1>2.高斯差分（DoG）滤波：</h1>
<p>在这个部分开始之前，首先要普及一下一些相关的知识点。</p>
<h2>2.1图像尺度空间</h2>
<p>在图像信息处理中引入一个名为尺度的参数，通过对图像进行一些变换，获得在多个尺度空间下的图像空间序列，对这些序列可以进行一些特征的提取等操作，可以实现边缘，角点检测和不同分辨率上的特征提取。</p>
<p>对这个尺度空间的理解：它可以模拟人在距离目标由近到远的过程中，目标在视网膜当中形成的图像的过程。尺度越大图像越模糊，相当于我们观察远处物体，这时候关注该物体的轮廓。如下图，我们看到远方只有两个人的外形，并不能看到衣服上的花纹。</p>
<p><img referrerpolicy="no-referrer"src="https://images2015.cnblogs.com/blog/871557/201610/871557-20161022224951592-1437471737.jpg" /></p>
<p>尺度空间满足视觉不变性。</p>
<ul><li><div>满足灰度不变性和对比度不变性：当我们用眼睛观察物体时，当物体所处背景的光照条件变化时，视网膜感知图像的亮度水平和对比度是不同的，因此要求尺度空间算子对图像的分析不受图像的灰度水平和对比度变化的影响。</div></li>
<li><div>满足平移不变性、尺度不变性、欧几里德不变性以及仿射不变性：相对于某一固定坐标系，当观察者和物体之间的相对位置变化时，视网膜所感知的图像的位置、大小、角度和形状是不同的，因此要求尺度空间算子对图像的分析和图像的位置、大小、角度以及仿射变换无关。</div></li></ul>
<p>一个图像的尺度空间<img referrerpolicy="no-referrer"src="https://images2015.cnblogs.com/blog/871557/201610/871557-20161022224951982-423857160.png" />表示在该尺度下，该坐标处的值。</p>
<h2>2.2二维高斯函数和高斯模糊</h2>
<p>下面这些只是一些基础性的知识，公式并不需要推导，接受就好。</p>
<p>高斯滤波器，使用正态分布计算的一种卷积模板（基本概念，这不懂的话，需要自己入门），利用高斯滤波器和图像进行卷积运算，可对图像进行模糊处理。公式如下（这是一个二维的高斯滤波器）：</p>
<p><img referrerpolicy="no-referrer"src="https://images2015.cnblogs.com/blog/871557/201610/871557-20161022224952279-1371766006.png" /></p>
<p>二维高斯曲面如下：</p>
<p><img referrerpolicy="no-referrer"src="https://images2015.cnblogs.com/blog/871557/201610/871557-20161022224952623-556307283.png" /></p>
<p>图3 高斯二维曲面</p>
<p>其中为正态分布的标准差，在高斯模糊中，它越大，图像越模糊。这里要定义一个模糊半径<img referrerpolicy="no-referrer"src="https://images2015.cnblogs.com/blog/871557/201610/871557-20161022224953045-1936831685.png" />,</p>
<p><img referrerpolicy="no-referrer"src="https://images2015.cnblogs.com/blog/871557/201610/871557-20161022224953373-288871225.png" />表示模板元素到模板中心的距离。</p>
<p>当然上面只是一个连续的曲面，在对图像进行高斯模糊的过程中需要的是高斯模板，这个模板和图像卷积便可得到高斯模糊图像。正态分布中，在大于3*的范围之外存在的概率占仅0.3%，所以在3*的范围之外，那些像素所起作用基本可以忽略不计了，所以高斯模板只需要计算<img referrerpolicy="no-referrer"src="https://images2015.cnblogs.com/blog/871557/201610/871557-20161022224953888-603159574.png" />的大小即可。根据的值计算可以计算出高斯模板。</p>
<p>最后提几条高斯模糊的特性（后面的理解中会被用到）</p>
<ol><li><div>高斯模糊具有圆对称性，模板是中心对称的</div></li>
<li><div>高斯模糊具有线性可分的性质，这样在计算卷积的时候就可以利用一行和一列的两个矩阵和图像进行卷积，可以大大减小计算量。下面的代码就是利用这个性质。</div></li>
<li><div>对同一张图片进行连续多次高斯模糊与只用一次大的高斯模糊，可以达到一样的效果。需要满足的是方和根的关系。如两次的模糊值分别为3和4，达到的效果可以只用5就可以。<img referrerpolicy="no-referrer"src="https://images2015.cnblogs.com/blog/871557/201610/871557-20161022224954217-572553961.png" /></div></li>
<li><div>高斯卷积核被证明是尺度变换唯一的变换核，也是唯一的线性核。</div></li></ol>
<p>下面是高斯模板的生成代码：</p>
<div>
<pre class="prettyprint linenums"> function[g,x] = gaussian_filter(sigma,sample)<br />
 sample = 3.5;<br />
 if ~exist('sample')<br />
     sample = 7.0/2.0;<br />
 end<br />
 %设置滤波阈值<br />
 n = *round(sample * sigma) + ;

 x = :n;<br />
 x = x-ceil(n/);<br />
 g = exp(-(x.^)/(*sigma^))/(sigma*sqrt(*pi));<br />
 end</pre>
</div>
<p>这里产生的是一行的高斯模板，即运用了对模板进行线性分解的这个性质。当<img referrerpolicy="no-referrer"src="https://images2015.cnblogs.com/blog/871557/201610/871557-20161022224954623-387314649.png" />时，该模板为</p>
<div>
<table>
<tbody>
<tr>
<td>
<p>6.60729028444640e-06</p>
</td>
<td>
<p>0.000426170838253310</p>
</td>
<td>
<p>0.00170911194387669</p>
</td>
<td>
<p>0.000426170838253310</p>
</td>
<td>
<p>6.60729028444640e-06</p>
</td>
</tr>
<tr>
<td>
<p>0.000426170838253310</p>
</td>
<td>
<p>0.0274880587288661</p>
</td>
<td>
<p>0.110237879438303</p>
</td>
<td>
<p>0.0274880587288661</p>
</td>
<td>
<p>0.000426170838253310</p>
</td>
</tr>
<tr>
<td>
<p>0.00170911194387669</p>
</td>
<td>
<p>0.110237879438303</p>
</td>
<td>
<p>0.442097064144154</p>
</td>
<td>
<p>0.110237879438303</p>
</td>
<td>
<p>0.00170911194387669</p>
</td>
</tr>
<tr>
<td>
<p>0.000426170838253310</p>
</td>
<td>
<p>0.0274880587288661</p>
</td>
<td>
<p>0.110237879438303</p>
</td>
<td>
<p>0.0274880587288661</p>
</td>
<td>
<p>0.000426170838253310</p>
</td>
</tr>
<tr>
<td>
<p>6.60729028444640e-06</p>
</td>
<td>
<p>0.000426170838253310</p>
</td>
<td>
<p>0.00170911194387669</p>
</td>
<td>
<p>0.000426170838253310</p>
</td>
<td>
<p>0</p>
</td>
</tr>
</tbody>
</table>
</div>
<p>当<img referrerpolicy="no-referrer"src="https://images2015.cnblogs.com/blog/871557/201610/871557-20161022224955060-684564961.png" />时，该高斯模糊的效果如图4</p>
<p><img referrerpolicy="no-referrer"src="https://images2015.cnblogs.com/blog/871557/201610/871557-20161022224955748-807009315.png" /></p>
<p>图4高斯模糊效果</p>
<h2>2.3高斯金字塔</h2>
<p>先说高斯金字塔要得到啥吧：</p>
<p>高斯金字塔主要是为了得到不同尺度的图片，这些图片的尺度必须是连续的，所以要对图片进行高斯滤波。高斯金字塔是一个原始图像，产生几组（octave）每一组中又包含着几层（interval）。如图5：</p>
<p><img referrerpolicy="no-referrer"src="https://images2015.cnblogs.com/blog/871557/201610/871557-20161022224956295-1975776590.png" /></p>
<p>图5高斯金字塔示意</p>
<p>当然在构建高斯金字塔之前还需要确定的是我们需要构建该金字塔的阶数（o）和每一组的层数（s）。</p>
<p>高斯金字塔的构建主要就是分成两步走</p>
<ol><li><div>对图像进行不同尺度的高斯模糊（操作上面已经介绍过了）。</div>
<p>关键：模糊尺度的确定</p></li>
<li><div>对高斯金字塔进行降采样</div>
<p>关键：降采样的母本图片的确定</p></li></ol>
<p>在高斯金字塔的构建中，图像每一组的大小与相应阶数的对应关系为：（原始图像以512*512为例）</p>
<div>
<table>
<tbody>
<tr>
<td>
<p>阶数</p>
</td>
<td>
<p>1</p>
</td>
<td>
<p>2</p>
</td>
<td>
<p>3</p>
</td>
<td>
<p>4</p>
</td>
<td>
<p>5</p>
</td>
<td>
<p>6</p>
</td>
<td>
<p>7</p>
</td>
<td>
<p>8</p>
</td>
<td>
<p>9</p>
</td>
</tr>
<tr>
<td>
<p>大小</p>
</td>
<td>
<p>512</p>
</td>
<td>
<p>256</p>
</td>
<td>
<p>128</p>
</td>
<td>
<p>64</p>
</td>
<td>
<p>32</p>
</td>
<td>
<p>16</p>
</td>
<td>
<p>8</p>
</td>
<td>
<p>4</p>
</td>
<td>
<p>2</p>
</td>
</tr>
</tbody>
</table>
</div>
<h2>2.4高斯差分金字塔（这一部分是结论性的知识）</h2>
<p>2002年Mikolajczyk在详细的实验比较中发现尺度归一化的高斯拉普拉斯函数<img referrerpolicy="no-referrer"src="https://images2015.cnblogs.com/blog/871557/201610/871557-20161022224956732-493367120.jpg" />的极大值和极小值同其它的特征提取函数（如：梯度，Hessian或Harris角特征）比较，能够产生最稳定的图像特征。</p>
<p>而Lindeberg早在1994年就发现高斯差分函数（Difference of Gaussian 算子）与尺度归一化的高斯拉普拉斯函数<img referrerpolicy="no-referrer"src="https://images2015.cnblogs.com/blog/871557/201610/871557-20161022224957076-967947978.jpg" />非常近似。其中<img referrerpolicy="no-referrer"src="https://images2015.cnblogs.com/blog/871557/201610/871557-20161022224957467-1204651716.jpg" />和<img referrerpolicy="no-referrer"src="https://images2015.cnblogs.com/blog/871557/201610/871557-20161022224957795-1838660024.jpg" />的关系可以从如下公式推导得到：</p>
<p><img referrerpolicy="no-referrer"src="https://images2015.cnblogs.com/blog/871557/201610/871557-20161022224958232-1620328566.jpg" /></p>
<p>利用差分近似代替微分，则有：</p>
<p><img referrerpolicy="no-referrer"src="https://images2015.cnblogs.com/blog/871557/201610/871557-20161022224958560-1861392548.jpg" /></p>
<p><img referrerpolicy="no-referrer"src="https://images2015.cnblogs.com/blog/871557/201610/871557-20161022224958904-887670941.jpg" /></p>
<p>其中k-1是个常数，并不影响极值点位置的求取。而高斯拉普拉斯和高斯差分的比较如图6：</p>
<p><img referrerpolicy="no-referrer"src="https://images2015.cnblogs.com/blog/871557/201610/871557-20161022224959248-1861325571.jpg" /></p>
<p>图6高斯拉普拉斯和高斯差分</p>
<p>如图所示，红色曲线表示的是高斯差分算子，而蓝色曲线表示的是高斯拉普拉斯算子。使用更高效的高斯差分算子代替拉普拉斯算子进行极值检测，如下：</p>
<p><img referrerpolicy="no-referrer"src="https://images2015.cnblogs.com/blog/871557/201610/871557-20161022225000013-1037591372.jpg" /></p>
<p>Ok讲到这里，聪明的读者就应该知道了，学习前面那么多的知识，只是为了对sift特征点的出场做铺垫。在实际计算时，使用高斯金字塔每组中相邻上下两层图像相减，得到高斯差分图像，如图7所示，进行极值检测。这样就能得到sift特征点的候选人，对，只是候选。</p>
<p><img referrerpolicy="no-referrer"src="https://images2015.cnblogs.com/blog/871557/201610/871557-20161022225000623-1035300704.jpg" /></p>
<p>图7高斯差分金字塔生成</p>
<h2>2.5高斯金字塔生成的细节</h2>
<p>上述所有的知识已经把sift关键点候选人的选举办法说清楚了，现在该讲一讲选举过程中所应该注意的4个问题，这样就把这一部分结束。</p>
<p>这两个问题归根到底还是高斯金字塔构建的过程中的4个问题。</p>
<ol><li><div>金字塔的阶数（o）的确定 </div></li>
<li><div>每一组层数（s）的确定 </div></li>
<li><div>每一层的尺度（）的确定 </div></li>
<li><div>下一组的图片降采样母本的确定 </div></li></ol>
<p>下面一一解答：</p>
<p>1、金字塔的阶数（O）一般为4，也可以根据图像大小来选择，但是要满足下列关系：</p>
<p><img referrerpolicy="no-referrer"src="https://images2015.cnblogs.com/blog/871557/201610/871557-20161022225001342-1342561184.png" /></p>
<p><img referrerpolicy="no-referrer"src="https://images2015.cnblogs.com/blog/871557/201610/871557-20161022225001748-1564516458.png" />分别表示图像的行数和列数。</p>
<p>2、每一阶的层数（S）一般选择5或者6，一般选择6的时候效果最好。在这边就要根据前面的说明，特征点的选举是要在相邻的两层差分金字塔上面进行检测的，所以要得到n个尺度的特征点，就要在<img referrerpolicy="no-referrer"src="https://images2015.cnblogs.com/blog/871557/201610/871557-20161022225002170-1477455978.png" />层的差分金字塔上检测，（自己画个图就ok了），然而要产生n+2层的差分金字塔，就要有n+3层的高斯金字塔，这样相邻的相减，才能产生n+2层差分。注意：这里的检测都是同阶里面不同层的操作。所以S = n + 3。记住这个n，有用！</p>
<p>3、尺度因子<img referrerpolicy="no-referrer"src="https://images2015.cnblogs.com/blog/871557/201610/871557-20161022225002545-1055606103.png" />的选择，或许这是本节中最让人头疼的一件事情了。然而在看完众多源码和例程之后我把自己的见解整理如下：</p>
<p>先要理解几个概念：</p>
<p>高斯金字塔的模糊尺度：这个尺度是我们产生模板的尺度</p>
<p>摄像头模糊的尺度：这个尺度是图像被相机镜头模糊后的尺度，一般为固定值，这里定义0.5。</p>
<p>图像的尺度：这个尺度是摄像头模糊尺度和高斯金字塔尺度的合作用，满足方和根的关系。Lowe定义图片的尺度为1.6。</p>
<p>这里插入解答第4个问题，即下一阶的第一层图像是根据上一阶的倒数第三层图像进行降采样得到的。见图8</p>
<p><img referrerpolicy="no-referrer"src="https://images2015.cnblogs.com/blog/871557/201610/871557-20161022225002967-239803729.png" /></p>
<p>图8降采样示意图</p>
<p>好了回来继续解答第三个问题，</p>
<p>在一阶的图像内，每一层之间的高斯模糊的尺度因子的比值为 <img referrerpolicy="no-referrer"src="https://images2015.cnblogs.com/blog/871557/201610/871557-20161022225003717-574500525.png" />,</p>
<p><img referrerpolicy="no-referrer"src="https://images2015.cnblogs.com/blog/871557/201610/871557-20161022225003998-1332265300.png" /></p>
<p>于是同一阶的第s层高斯模糊尺度<img referrerpolicy="no-referrer"src="https://images2015.cnblogs.com/blog/871557/201610/871557-20161022225004295-25746368.png" />就变成了,这里面<img referrerpolicy="no-referrer"src="https://images2015.cnblogs.com/blog/871557/201610/871557-20161022225004717-653952117.png" />是这一阶的第一层图像的高斯模糊尺度。</p>
<p><img referrerpolicy="no-referrer"src="https://images2015.cnblogs.com/blog/871557/201610/871557-20161022225005013-1352104141.png" /></p>
<p>根据图7所示，第n+1阶的图像，它的高斯模糊尺度是<img referrerpolicy="no-referrer"src="https://images2015.cnblogs.com/blog/871557/201610/871557-20161022225005420-997443215.png" />，这个图像的高斯模糊带到了下一阶的第一层图像中去，于是不同阶相同层的高斯模糊尺度是2倍关系。如图9所示</p>
<p><img referrerpolicy="no-referrer"src="https://images2015.cnblogs.com/blog/871557/201610/871557-20161022225005935-393976818.png" /></p>
<p>图9不同层之间的尺度示意</p>
<p>综上可以概括出阶内及阶之间的尺度关系了。</p>
<p><img referrerpolicy="no-referrer"src="https://images2015.cnblogs.com/blog/871557/201610/871557-20161022225006576-353087643.png" /></p>
<p>i：表示第i阶的图像</p>
<p>s：表示阶内第s层的图像</p>
<p>在理清楚图像互相之间的关系之后，我们需要的是第一阶，第一层的高斯模糊尺度，这样就能根据上述关系，搞到所有的告示模糊尺度了。还记得两个数吗？0.5和1.6，这时候就派上用场了。</p>
<p>在lowe的论文中，他定义图片的尺度是1.6，被摄像头模糊的尺度是0.5，于是可以算得高斯模糊是</p>
<p><img referrerpolicy="no-referrer"src="https://images2015.cnblogs.com/blog/871557/201610/871557-20161022225006951-793492573.png" /></p>
<p>但是这个1.52对我们来说并没有啥意思，lowe为了获得更多的特征点（姑且这么解释吧）他先对原始图像进行扩大一倍。然后呢再对它进行高斯平滑作为第一阶第一层，这时候它的高斯模糊尺度为</p>
<p><img referrerpolicy="no-referrer"src="https://images2015.cnblogs.com/blog/871557/201610/871557-20161022225007498-1425294849.png" /></p>
<p>于是得到最开始的高斯模糊尺度。这下可以得到所有的高斯模糊尺度了。</p>
<p>到此为止，我们讲完所有理论的工作了，然而在实际实现中，同一阶第s+1层的图片是在第s层图片的基础上进行高斯模糊得到的，还记得那个方和根的关系吧。故，第s+1层图片由第s层图片用一个尺度<img referrerpolicy="no-referrer"src="https://images2015.cnblogs.com/blog/871557/201610/871557-20161022225007873-1792265260.png" />的模板进行高斯卷积得到。</p>
<p><img referrerpolicy="no-referrer"src="https://images2015.cnblogs.com/blog/871557/201610/871557-20161022225008263-549890614.png" /></p>
<p>最后产生高斯金字塔，相邻层相减，便得到高斯差分金字塔。附上这一部分的生成代码：</p>
<div>
<pre class="prettyprint linenums"> im = imread('gray_testImage1.jpg');<br />
     im = im2double(im);<br />
  % 设定输入量的默认值<br />
 if ~exist('octaves')   %%最大的阶数<br />
     octaves = ;<br />
  end<br />
  if ~exist('intervals')%%每一阶最大的层数<br />
     intervals = ;<br />
  end<br />
  if ~exist('object_mask')%%计算模板大小<br />
     object_mask = ones(size(im));<br />
  end<br />
  if size(object_mask) ~= size(im)<br />
     object_mask = ones(size(im));<br />
  end<br />
  if ~exist('contrast_threshold')<br />
     contrast_threshold = 0.02;%%设置去除低对比度特征点阈值大小<br />
  end<br />
  if ~exist('curvature_threshold')<br />
     curvature_threshold = 10.0;%%设置去除边缘特征点阈值大小<br />
  end<br />
  if ~exist('interactive')%%设置迭代次数<br />
     interactive = ;<br />
  end<br />
 interactive = ;

  % 检验输入灰度图像的像素灰度值是否已归一化到[,]<br />
  if( (min(im(:)) &lt; ) | (max(im(:)) &gt; ) )<br />
     fprintf( , 'Warning: image not normalized to [0,1].\n' );

  end

  % 将输入图像经过高斯平滑处理，采用双线性差值将其扩大一倍.<br />
 if interactive &gt;=<br />
     fprintf( , 'Doubling image size for first octave...\n' );<br />
 end

  tic;<br />
  antialias_sigma = 0.5;           %%高斯平滑参数<br />
  if antialias_sigma ==          %%不进行平滑操作<br />
     signal = im;<br />
  else<br />
     g = gaussian_filter( antialias_sigma );   %%%产生高斯模板<br />
     if exist('corrsep') ==<br />
             signal = corrsep( g, g, im );<br />
     else<br />
        signal = conv2( g, g, im, 'same' );  %%高斯卷积<br />
     end<br />
  end<br />
  signal = im;<br />
  [X Y] = meshgrid( :0.5:size(signal,), :0.5:size(signal,) );<br />
  signal = interp2( signal, X, Y, 'linear' );   %%双线性插值扩展图片<br />
  subsample = [0.5]; %  降采样率；

  %下一步是生成高斯和差分高斯(DOG)金字塔，这两个金字塔的数据分别存储在名为gauss_pyr{orient,interval}<br />
  % 和DOG_pyr{orient,interval}的元胞数字中。高斯金字塔含有s+3层，差分高斯金字塔含有s+2层。

 if interactive &gt;=<br />
     fprintf( , 'Prebluring image...\n' );<br />
 end

  preblur_sigma = sqrt(sqrt()^ - (*antialias_sigma)^);<br />
  if preblur_sigma ==<br />
     gauss_pyr{,} = signal;  %%matlab cell数据类型有待考证<br />
  else<br />
     g = gaussian_filter( preblur_sigma );<br />
     if exist('corrsep') ==<br />
        gauss_pyr{,} = corrsep( g, g, signal );<br />
     else<br />
        gauss_pyr{,} = conv2( g, g, signal, 'same' );<br />
     end<br />
  end<br />
  clear signal<br />
  pre_time = toc;<br />
  if interactive &gt;=<br />
     fprintf( , 'Preprocessing time %.2f seconds.\n', pre_time );<br />
  end

  initial_sigma = sqrt(( * antialias_sigma)^ + preblur_sigma^);%计算第一层第一阶模糊金字塔的sigma值

  %%计算不同阶层的siama<br />
  absolute_sigma = zeros(octaves,intervals + );<br />
  absolute_sigma(,) = initial_sigma * subsample();

  %%对生成的金字塔的滤波核大小和标准差进行跟踪<br />
  filter_size = zeros(octaves, intervals+);<br />
  filter_sigma = zeros(octaves, intervals+);

  tic<br />
  %%计算差分高斯金字塔<br />
  for octave = :octaves<br />
      sigma = initial_sigma;<br />
      g = gaussian_filter(sigma);<br />
      filter_size(octave,) = length(g);<br />
      filter_sigma(octave,) = sigma;<br />
      DOG_pyr{octave} = zeros(size(gauss_pyr{octave,},),size(gauss_pyr{octave,},),intervals+);

      %%从第二层计算差分金字塔<br />
      for interval = :(intervals + )<br />
          sigma_f = sqrt(^(/intervals) - ) * sigma;<br />
          g = gaussian_filter(sigma_f);<br />
          sigma = (^(/intervals)) *sigma   %%得到下一个sigma<br />
          absolute_sigma(octave,interval) = sigma * subsample(octave);<br />
          %存储滤波器的核大小及标准差<br />
          filter_size(octave,interval) = length(g);<br />
          filter_sigma(octave,interval) = sigma;<br />
          if exist('corrsep')==<br />
              gauss_pyr{octave,interval} = corrsep(g,g,gauss_pyr{octave,interval - });<br />
          else<br />
              gauss_pyr{octave,interval} = conv2(g,g,gauss_pyr{octave,interval - },'same');<br />
          end<br />
          DOG_pyr{octave}(:,:,interval - ) = gauss_pyr{octave,interval} - gauss_pyr{octave,interval -};<br />
      end<br />
      if octave &lt; octaves<br />
          sz = size(gauss_pyr{octave,intervals + });<br />
          [X,Y]= meshgrid(::sz(),::sz());<br />
          gauss_pyr{octave + ,} = interp2(gauss_pyr{octave,intervals + },X,Y,'*nearest');<br />
          abslute_sigma(octave+,) = absolute_sigma(octave,intervals+);<br />
          subsample = [subsample subsample(end)*];<br />
      end<br />
  end<br />
  pyr_time = toc;

  % 在交互模式下显示高斯金字塔<br />
 if interactive &gt;=<br />
    sz = zeros(,);<br />
    sz() = (intervals+)*size(gauss_pyr{,},);<br />
    for octave = :octaves<br />
       sz() = sz() + size(gauss_pyr{octave,},);<br />
    end<br />
    pic = zeros(sz);<br />
    y = ;<br />
    for octave = :octaves<br />
       x = ;<br />
       sz = size(gauss_pyr{octave,});<br />
       for interval = :(intervals + )<br />
                         pic(y:(y+sz()-),x:(x+sz()-)) = gauss_pyr{octave,interval};<br />
          x = x + sz();<br />
       end<br />
       y = y + sz();<br />
    end<br />
    fig = figure;<br />
    clf;<br />
    imshow(pic);<br />
 %    resizeImageFig( fig, size(pic), 0.25 );<br />
 %    fprintf( , 'The gaussian pyramid (0.25 scale).\nPress any key to continue.\n' );<br />
 %    pause;<br />
 %    close(fig)<br />
 end

 % 在交互模式下显示差分高斯金字塔<br />
 if interactive &gt;=<br />
    sz = zeros(,);<br />
    sz() = (intervals+)*size(DOG_pyr{}(:,:,),);<br />
    for octave = :octaves<br />
       sz() = sz() + size(DOG_pyr{octave}(:,:,),);<br />
    end<br />
    pic = zeros(sz);<br />
    y = ;<br />
    for octave = :octaves<br />
       x = ;<br />
       sz = size(DOG_pyr{octave}(:,:,));<br />
       for interval = :(intervals + )<br />
                         pic(y:(y+sz()-),x:(x+sz()-)) = DOG_pyr{octave}(:,:,interval);<br />
          x = x + sz();<br />
       end<br />
       y = y + sz();<br />
    end<br />
    fig = figure;<br />
    imshow(pic);<br />
 %    clf;<br />
 %    imagesc(pic);%%%这个函数可以调整图像显示<br />
 %    resizeImageFig( fig, size(pic), 0.25 );<br />
 %    fprintf( , 'The DOG pyramid (0.25 scale).\nPress any key to continue.\n' );<br />
 %    pause;<br />
 %    close(fig)<br />
 end</pre>
</div>
<p>高斯金字塔：</p>
<p><img referrerpolicy="no-referrer"src="https://images2015.cnblogs.com/blog/871557/201610/871557-20161022225009435-2014746666.png" /></p>
<p>Ok，至此，我们完成第一部分的高斯滤波和金字塔构建工作。</p>
<p>最后，我要贴上几个引导我学习的博客文章链接，对你们表示感谢！尊重作者的劳动成果，知识共享，但不代表着盗取！</p>
<p>未经本人同意禁止转载！</p>
<p>http://blog.csdn.net/zddblog/article/details/7450033</p>												<div id="single_bottom"></div>
<script>insertAdIfNeeded();</script>
																
<h2>最新文章</h2>	
<ol>
						<li><a href="https://www.batexi.com/a/o8ojr35q.html">DelphiXE10&period;1获取Administrator所有权的方法</a>
		</li>
						<li><a href="https://www.batexi.com/a/m8zk3m18.html">MySQL插入语句解析</a>
		</li>
						<li><a href="https://www.batexi.com/a/0qw0d0y9.html">BW顾问必需要清楚的：时间相关数据建模场景需求分析</a>
		</li>
						<li><a href="https://www.batexi.com/a/495y5keq.html">Python基础之【第三篇】</a>
		</li>
						<li><a href="https://www.batexi.com/a/39rem74q.html">3、面向对象以及winform的简单运用（类的初步认识）</a>
		</li>
						<li><a href="https://www.batexi.com/a/xq4r0mj8.html">洛谷1352  CODEVS1380 没有上司的舞会</a>
		</li>
						<li><a href="https://www.batexi.com/a/8k1mj679.html">Eclipse新版 syso无法自动补全的解决方法</a>
		</li>
						<li><a href="https://www.batexi.com/a/8k12zj79.html">Vieta定理</a>
		</li>
						<li><a href="https://www.batexi.com/a/q2we47lq.html">namenode启动参数</a>
		</li>
						<li><a href="https://www.batexi.com/a/9gm7gp79.html">tengine rpm制作</a>
		</li>
						<li><a href="https://www.batexi.com/a/qxn3yed8.html">linux有用网址</a>
		</li>
						<li><a href="https://www.batexi.com/a/qn1p1lj8.html">iOS7状态栏字体颜色修改</a>
		</li>
						<li><a href="https://www.batexi.com/a/q1kz7x29.html">poj1679（最小生成树）</a>
		</li>
						<li><a href="https://www.batexi.com/a/qljjx619.html">wpf 9张图片的连连看</a>
		</li>
						<li><a href="https://www.batexi.com/a/9pdym3k9.html">java1 - 环境与简介</a>
		</li>
						<li><a href="https://www.batexi.com/a/qxkm6208.html">恶补web之六&colon;javascript知识&lpar;1&rpar;</a>
		</li>
						<li><a href="https://www.batexi.com/a/95grnvzq.html">记一次Debug过程</a>
		</li>
						<li><a href="https://www.batexi.com/a/9j1lo0l9.html">web文件上传</a>
		</li>
						<li><a href="https://www.batexi.com/a/9j1lw0e9.html">C&num; 可指定并行度任务调度器</a>
		</li>
						<li><a href="https://www.batexi.com/a/q1r2l748.html">Windows 10 中 VMware 要求禁用 Device Guard 问题</a>
		</li>
		</ol>
	

<h2>热门文章</h2>	
<ol>
									<li><a href="https://www.batexi.com/a/qy22r7x9.html">HTML5拖拽练习</a>
			</li>
						<li><a href="https://www.batexi.com/a/9pmm3n79.html">Nginx &plus; Keepalived使用文档</a>
			</li>
						<li><a href="https://www.batexi.com/a/9pmm3w79.html">FLT&lowbar;MIN&comma;FLT&lowbar;MAX&comma;FLT&lowbar;EPSILON</a>
			</li>
						<li><a href="https://www.batexi.com/a/qy226kx9.html">Hyperledger Fabric 实战&lpar;十&rpar;&colon; Fabric node SDK 样例 - 投票DAPP</a>
			</li>
						<li><a href="https://www.batexi.com/a/qwoo4zl9.html">BZOJ3572：&lbrack;HNOI2014&rsqb;世界树&mdash;&mdash;题解</a>
			</li>
						<li><a href="https://www.batexi.com/a/9g33x17q.html">BZOJ2242  &lbrack;SDOI2011&rsqb;计算器   【BSGS】</a>
			</li>
						<li><a href="https://www.batexi.com/a/q2xxv4x9.html">修改tomcat编码格式 &amp;amp&semi; tomcat发布WEB项目供外网访问</a>
			</li>
						<li><a href="https://www.batexi.com/a/9r443w78.html">hdu 5616</a>
			</li>
						<li><a href="https://www.batexi.com/a/8e006ezq.html">MQ对比</a>
			</li>
						<li><a href="https://www.batexi.com/a/9r44lrm8.html">gulp压缩css和js</a>
			</li>
			</ol>			
							
					</div>

					
<div class="next-prev-posts clearfix">
</div>
						 
				</div>
				
	<div class="clear"></div>

			</div>	
			

		</div>
</div>
</div>


<div class="clearfix"></div>
<div id="footer" class="two-s-footer">
	<div class="footer-box">
		<div class="container">
			<div class="row" style="padding-left: 15px;padding-right: 15px;">
			<div class="nav-footer">
				<a href="/">Home</a>
				</div>
				<div class="copyright-footer">
					<p>Powered By WordPress</p>
				</div>
							</div>
		</div>
	</div>
</div>
<div style="display:none">

</div>
<script src="//n4.ikafan.com/assets/js/echo.js"></script>
<script>
    echo.init({
      offset: 100,
      throttle: 250,
      unload: false,
      callback: function (element, op) {
        console.log(element, 'has been', op + 'ed')
      }
    });
 </script>
</body>
</html>
